package id.ac.telkomuniversity.tass.praktekhttp;

import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.List;

public class MainActivity extends AppCompatActivity {
    ListView listView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        listView = (ListView) findViewById(R.id.listView1);
    }

    String URL = "http://drf-demo.herokuapp.com/api/universities/?format=json";
    @Override
    protected void onStart() {
        super.onStart();
        new UniversityDownloadTask().execute(URL);
    }

    private class UniversityDownloadTask extends AsyncTask<String, Void,
            List<University>> {

        @Override
        protected List<University> doInBackground(String... strings) {
            List<University> output = null;
            try {
                HttpRequest request =  HttpRequest.get(strings[0]);
                request.acceptJson();
                if (request.ok()) {
                    String result = request.body();
                    Log.i("TASK", result);
                    output = parse(result);
                }
            } catch (HttpRequest.HttpRequestException exception) {
                Log.e("TASK", "Gagal melakukan koneksi");
            }
            return output;
        }

        private List<University> parse(String response) {
            List<University> list = new ArrayList<>();

            try {
                JSONArray array = new JSONArray(response);
                for (int i = 0; i < array.length(); i++) {
                    University u = new University();
                    JSONObject o = array.getJSONObject(i);
                    u.setId(o.getInt("id"));
                    u.setName(o.getString("name"));
                    list.add(u);
                }
            } catch (JSONException e) {
                e.printStackTrace();
                Log.e("TASK", "Tidak berhasil memproses JSON");
            }

            return list;
        }

        @Override
        protected void onPostExecute(List<University> list) {
            Log.i("TASK", "Jumlah entri list: " + list.size());

            ArrayAdapter<University> adapter = new ArrayAdapter<>(
                    MainActivity.this,
                    android.R.layout.simple_list_item_1,
                    list);
            listView.setAdapter(adapter);
        }

    }
}
